[Overview][Constants][Types][Classes][Procedures and functions][Variables][Index] | Reference for unit 'Controls' (#lcl)

# TWinControl.ControlKeyUp

Handles key up events for special navigation keys.

## Declaration

Source position: controls.pp line 2269

`protected procedure TWinControl.ControlKeyUp(`
`var Key: Word;`
`Shift: TShiftState`
`); virtual;`

## Arguments

`Key` |  | Numeric key code examined in the method.
`Shift` |  | Shift, Ctrl, or Alt modifier for the key.

## Description

ControlKeyUp is a method used to detect and handle key up events for navigation keys used in the control. ControlKeyUp calls the corresponding method in TApplication to determine the actions needed for the key and modifier. The application handles Return (Enter) and Escape keys which may affect control or form focus.

ControlKeyUp is called from the DoRemainingKeyUp method to handle keys not otherwise handled by a control or its parent forms.

## See also

TWinControl.DoRemainingKeyUp |  | Handles key up messages not already handled by the widget.
TApplication.ControlKeyUp |  | Handles KeyUp events in a Control, e.g. handles Enter and Esc keys.
TApplication.DoReturnKey |  | Interprets Enter as the default action, if applicable.
TApplication.DoEscapeKey |  | Interprets Esc as Cancel action, if applicable.